// $Id: UnicodeParser.js,v 1.1.2.5 2005/08/04 00:04:08 vnagarjuna Exp $ -->

//Copyright 2005 Nagarjuna Venna <vnagarjuna@yahoo.com>

/* ****** BEGIN LICENSE BLOCK ***** 
 *  This file is part of Padma.
 *
 *  Padma is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Padma is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Padma; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * ***** END LICENSE BLOCK ***** */

//Parser for Unicode Text - returns syllables

function UnicodeParser(input) {
    this.index = 0;
    this.length = input.length;
    this.text = input;
}

function UnicodeParser_next()
{
    var response = "";

    var remaining = this.length - this.index;
    for(; remaining > 0; remaining = this.length - this.index) {
        var maxLookupLen = remaining > Unicode.maxLookupLen ? Unicode.maxLookupLen : remaining;
        
        var key, value;
        for(var i = maxLookupLen; i > 0; i--) {
            key = this.text.substring(this.index, this.index + i);
            //alert("looking up " + key);
            value = Unicode.lookup(key);
            if (value != null) {
                break;
            }
        }

        response = this.handleInput(value, key, response);
        if (this.state == Parser.state_START)
            return response;
    }

    return response.length != 0 ? response : null;
}

//This doesn't seem to work in extension mode, add any mods to relationships.js too
UnicodeParser.prototype = new Parser("");
UnicodeParser.prototype.next = UnicodeParser_next;

